> For a complete page index, fetch https://developer.close.com/llms.txt # Meeting Search Meetings, apart from normal activity search, can be searched by provider calendar information i.e. the underlying calendar events they were created from. The searchable fields are: - `provider_calendar_event_id` - **required**, the provider event ID the meeting was synced from - `provider_calendar_id` - the provider calendar ID the meeting was synced from - `provider_calendar_type` - either `"google"` or `"microsoft"` - `starts_at` - the meeting start time, useful for finding meetings created from instances of recurring events When searching on one of those fields you must always provide at least `provider_calendar_event_id` or you will receive an error. `starts_at` apart from exact matches can be searched on ranges by using `start_at__gte` and `starts_at__lt`. ## Examples Search for meetings with given provider calendar `EVENT_ID` across all the leads in the organization. ``` https://api.close.com/api/v1/activity/meeting/?provider_calendar_event_id=EVENT_ID ``` Search for meetings with given provider calendar `EVENT_ID` that start at 3 pm on 09/19/2023 UTC across all the leads in the organization. ``` https://api.close.com/api/v1/activity/meeting/?provider_calendar_event_id=EVENT_ID&starts_at=2023-09-19T15:00:00 ``` Search for meetings with given provider calendar `EVENT_ID` and calendar `CALENDAR_ID` across all the leads in the organization. ``` https://api.close.com/api/v1/activity/meeting/?provider_calendar_event_id=EVENT_ID&provider_calendar_id=CALENDAR_ID ``` Search for meetings with given provider calendar `EVENT_ID` coming from Google Calendar that start between 09/20/2023 midnight UTC inclusive and 09/21/2023 midnight UTC exclusive on a lead `LEAD_ID` in the organization. ``` https://api.close.com/api/v1/activity/meeting/?provider_calendar_event_id=EVENT_ID&provider_calendar_type=google&starts_at__gte=2023-09-20&starts_at__lt=2023-09-21&lead_id=LEAD_ID ``` ## Google calendar provider information `provider_calendar_event_id` is the same as `id` property on an [Event resource](https://developers.google.com/calendar/api/v3/reference/events#resource-representations), similarly `provder_calendar_id` is the same as `id` property on a [Calendar resource](https://developers.google.com/calendar/api/v3/reference/calendars#resource-representations). Google always addresses events with this pair i.e. when fetching them with their API you have to [provide both](https://developers.google.com/calendar/api/v3/reference/events/get). If you happen to have `htmlLink` property of [Event resource](https://developers.google.com/calendar/api/v3/reference/events) it's possible to decompose it to both IDs. For example given: ``` https://www.google.com/calendar/event?eid=ZDYzOWZhMWM3ZWEzNDRjNzk3ZGYxZDBmNTE2MDMxMTMgZXhhbXBsZUBjbG9zZS5jb2 ``` one can base64 decode `eid` query parameter `ZDYzOWZhMWM3ZWEzNDRjNzk3ZGYxZDBmNTE2MDMxMTMgZXhhbXBsZUBjbG9zZS5jb2` to space separated `d639fa1c7ea344c797df1d0f51603113 example@close.com` which can be passed to `provider_calendar_event_id` and `provider_calendar_id` respectively. The same can be done with an edit link which can be seen if you double click on an event in the web UI. For example given: ``` https://calendar.google.com/calendar/u/1/r/eventedit/ZDYzOWZhMWM3ZWEzNDRjNzk3ZGYxZDBmNTE2MDMxMTMgZXhhbXBsZUBjbG9zZS5jb20 ``` the last path component `ZDYzOWZhMWM3ZWEzNDRjNzk3ZGYxZDBmNTE2MDMxMTMgZXhhbXBsZUBjbG9zZS5jb20` decomposes to `d639fa1c7ea344c797df1d0f51603113 example@close.com` which, again, can be passed to `provider_calendar_event_id` and `provider_calendar_id` respectively. Note that depending on your base64 decode implementation you might need to add extra `=` characters at the end to satisfy base64 padding requirements as Google strips those. Here's a [Python example](https://stackoverflow.com/questions/2941995/python-ignore-incorrect-padding-error-when-base64-decoding#49459036). ## Microsoft calendar provider information `provider_calendar_event_id` is the same as `id` property on an [Event resource](https://learn.microsoft.com/en-us/graph/api/resources/event?view=graph-rest-1.0#properties), similarly `provider_calendar_id` is the same as `id` property on a [Calendar resource](https://learn.microsoft.com/en-us/graph/api/resources/calendar?view=graph-rest-1.0#properties). If you happen to have `webLink` property of an [Event resource](https://learn.microsoft.com/en-us/graph/api/resources/event?view=graph-rest-1.0#properties) one can find `provider_calendar_event_id` there as `itemid` query parameter. For example given: ``` https://outlook.office365.com/owa/?itemid=AAMkADdiYzg5OGRlLTY1MjktNDc2Ni05YmVkLWMxMzFlNTQ0MzU3YQBGAAAAAACi9RQWB%2FSNTZBuALM6KIOsBwBtf4g8yY%2BzTZgZh6x0X%2F50AAAAAAENAABtf4g8yY%2BzTZgZh6x0X%2F50AALLI4%2FVAAA%3D&exvsurl=1&path=/calendar/item ``` `AAMkADdiYzg5OGRlLTY1MjktNDc2Ni05YmVkLWMxMzFlNTQ0MzU3YQBGAAAAAACi9RQWB-SNTZBuALM6KIOsBwBtf4g8yY_zTZgZh6x0X-50AAAAAAENAABtf4g8yY_zTZgZh6x0X-50AALLI4-VAAA=` could be passed as `provider_calendar_event_id`. The same can be done with details link which can be seen if you double click on an event in the web UI. For example given: ``` https://outlook.office.com/calendar/item/AAMkADdiYzg5OGRlLTY1MjktNDc2Ni05YmVkLWMxMzFlNTQ0MzU3YQBGAAAAAACi9RQWB%2FSNTZBuALM6KIOsBwBtf4g8yY%2BzTZgZh6x0X%2F50AAAAAAENAABtf4g8yY%2BzTZgZh6x0X%2F50AALmRd2BAAA%3D ``` the last path component `AAMkADdiYzg5OGRlLTY1MjktNDc2Ni05YmVkLWMxMzFlNTQ0MzU3YQBGAAAAAACi9RQWB-SNTZBuALM6KIOsBwBtf4g8yY_zTZgZh6x0X-50AAAAAAENAABtf4g8yY_zTZgZh6x0X-50AALLI4-VAAA=` could be passed as `provider_calendar_event_id`. > Search meetings by provider calendar information such as event ID, calendar ID, or account ID.